 
#include <iostream>
#include <string>
#include <sstream>
using namespace std;

template <class T>
class Par {
  private:
    T values[2];
  public:
    Par(T first, T second) {
	  values[0] = first;
	  values[1] = second;
    }
    T getFirst() {
	return values[0];
    }
    T getSecond() {
	return values[1]; 
    }
    void setFirst(T first) {
	values[0] = first;
    }
    void setSecond(T second) {
	values[1] = second;
    }
    T getMax() {
	return (values[0] > values[1]) ? values[0] : values[1];
    }
};

class Book {
  private:
    string title;
    string author;
    int year;
  public:
    Book() {
	title = "";
	author = "";
	year = 0;
    }
    Book(string title, string author, int year) {
	this->title = title;
	this->author = author;
	this->year = year;
    }
    string getBook() {
	stringstream description;
	description << title << " " << author << " " << year;
	return (description.str());
    }
};


int main( int argc, char* argv[] ){
    
    Par<int> p1(4, 9);
    Par<double> p2(10.9, 30.3);
   
    cout << p1.getFirst() << ", " << p1.getSecond() << endl;
    cout << "Maior do par 1 : " << p1.getMax() << endl;
    cout << p2.getFirst() << ", " << p2.getSecond() << endl;
    cout << "Maior do par 2 : " << p2.getMax() << endl;
    
    Book b1("C++","Deitel",2008);
    Book b2("Java","Barnes",2010);
  
    // por ser generica, Par funciona com qualquer classe
    Par<Book> parbook(b1, b2);
    
    // acesso cada objeto (primeiro e segundo)
    // e por eles posso chamar qualquer metodo publico de Book
    cout << parbook.getFirst().getBook() << endl;
    cout << parbook.getSecond().getBook() << endl;    
    
    // no entanto getMax() utiliza o operador > 
    // que nao esta definido para Book, e gera um erro
    // cout << "Maior entre os dois livros : " << parbook.getMax() << endl;
    return 0;
}
