 
#include <iostream>
#include <string>
#include <sstream>
using namespace std;

// a classe Par possui um tipo T generico
// eh preciso observar se as operacoes realizadas
// estarao definidas na classe utilizada (implementada)
template <class T>
class Par {
  private:
    T values[2];
  public:
    Par(T first, T second) {
	  values[0] = first;
	  values[1] = second;
    }
    T getFirst() {
	return values[0];
    }
    T getSecond() {
	return values[1]; 
    }
    void setFirst(T first) {
	values[0] = first;
    }
    void setSecond(T second) {
	values[1] = second;
    }
    // metodo so funciona para classes comparaveis com 
    // o operador '>' 
    T getMax() {
	return (values[0] > values[1]) ? values[0] : values[1];
    }
};

class Book {
  private:
    string title;
    string author;
    int year;
  public:
    Book() {
	title = "";
	author = "";
	year = 0;
    }
    Book(string title, string author, int year) {
	this->title = title;
	this->author = author;
	this->year = year;
    }
    string getBook() {
	stringstream description;
	description << title << " " << author << " " << year;
	return (description.str());
    }
};

// template - especializacao para uma determinada classe
// eh uma 'instancia' de Par para classes Book
template <>
class Par<Book> {
  private:
    Book values[2];
  public:
    Par(Book first, Book second) {
	  values[0] = first;
	  values[1] = second;
    }
    Book getFirst() {
	return values[0];
    }
    Book getSecond() {
	return values[1]; 
    }
    void setFirst(Book first) {
	values[0] = first;
    }
    void setSecond(Book second) {
	values[1] = second;
    }
    // removido o metodo getMax()
    // inserido um novo metodo, print()
    void print() {
	cout << values[0].getBook() << endl;
	cout << values[1].getBook() << endl << endl;	
    }    
};


int main( int argc, char* argv[] ){
    
    Par<int> p1(4, 9);
    Par<double> p2(10.9, 30.3);
     
    Book b1("C++","Deitel",2008);
    Book b2("Java","Barnes",2010);
    
    Par<Book> parbook(b1, b2);
    
    cout << parbook.getFirst().getBook() << endl;
    cout << parbook.getSecond().getBook() << endl;    
    
   // nao funciona pois no template especializado nao existe getMax
   // cout << "Maior entre os dois livros : " << parbook.getMax() << endl;
   
    parbook.print();
    return 0;
}
